/********************************************************************
 FileName:      HardwareProfile - Low Pin Count USB Development Kit.h
 Dependencies:  See INCLUDES section
 Processor:     PIC18F14K50 USB Microcontrollers
 Hardware:      Low Pin Count USB Development Kit
 Compiler:      Microchip C18
 Company:       Microchip Technology, Inc.

 쌠F\tgEGẤAMicrochipЂSoftware License Agreement
         ɏ܂BKAMicrochipЂAgreementemFĂB
         {RgȂǂ̒ǉ̒쌠́A҂ۗLA
         ҂̋𓾂ȂAŜшꕔ̓]ځEp֎~܂B

********************************************************************
 Change History:
  Rev   Date         Description
  1.0   2012/5/21   Initial release
********************************************************************/

#ifndef HARDWARE_PROFILE_LOW_PIN_COUNT_USB_DEVELOPMENT_KIT_H
#define HARDWARE_PROFILE_LOW_PIN_COUNT_USB_DEVELOPMENT_KIT_H

    /*******************************************************************/
    /******** USB stack hardware selection options *********************/
    /*******************************************************************/
    //MCHPFSUSB framework𓮍삳邽߂ɕKvȒ`ɏW߂
    //  ܂BŒ߂`́Afirmware ɂǂ̂悤ȃ[hœ
    //  ̂AɕKvȏ񋟂܂B
    //ǂ̍ڂAȂ̖ړIƂAvP[VɕKvATdɌ
    //  AK؂ȕύXĂB

    //#define USE_SELF_POWER_SENSE_IO	
    #define tris_self_power     TRISAbits.TRISA2    // Input
    #if defined(USE_SELF_POWER_SENSE_IO)
    #define self_power          PORTAbits.RA2
    #else
    #define self_power          1
    #endif

    //#define USE_USB_BUS_SENSE_IO
    #define tris_usb_bus_sense  TRISAbits.TRISA1    // Input
    #if defined(USE_USB_BUS_SENSE_IO)
    #define USB_BUS_SENSE       PORTAbits.RA1
    #else
    #define USB_BUS_SENSE       1
    #endif

    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /******** Application specific definitions *************************/
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/

    //HID Bootloader𗘗p HEX t@Co͂ɂ́Aȉ̍s 
    //  RgOĂB 
    #define PROGRAMMABLE_WITH_USB_HID_BOOTLOADER	

    /** Board definition ***********************************************/
    //ɏĂ̒`́Amain()[`ɁAǂ̃{[hgp
    //  邩̂łB  ̒`ɂAgp{[h̓K؂
    //  configuration bits̐ݒA\ɂ܂B
    //A̒`́AfvOpɏꂽ̂łA
    //  Ȃ̍쐬ŏIIȃAvP[VɓK̂Ƃ͌
    //  ܂B
    
    #define DEMO_BOARD LOW_PIN_COUNT_USB_DEVELOPMENT_KIT
    #define LOW_PIN_COUNT_USB_DEVELOPMENT_KIT
    #define CLOCK_FREQ 48000000
    #define GetSystemClock() CLOCK_FREQ
    
    /** LED ************************************************************/
    #define mInitAllLEDs()      LATC &= 0xF0; TRISC &= 0xF0;
    
    #define mLED_1              LATCbits.LATC0
    #define mLED_2              LATCbits.LATC1
    #define mLED_3              LATCbits.LATC2
    #define mLED_4              LATCbits.LATC3
    
    #define mGetLED_1()         mLED_1
    #define mGetLED_2()         mLED_2
    #define mGetLED_3()         mLED_3
    #define mGetLED_4()         mLED_4

    #define mLED_1_On()         mLED_1 = 1;
    #define mLED_2_On()         mLED_2 = 1;
    #define mLED_3_On()         mLED_3 = 1;
    #define mLED_4_On()         mLED_4 = 1;
    
    #define mLED_1_Off()        mLED_1 = 0;
    #define mLED_2_Off()        mLED_2 = 0;
    #define mLED_3_Off()        mLED_3 = 0;
    #define mLED_4_Off()        mLED_4 = 0;
    
    #define mLED_1_Toggle()     mLED_1 = !mLED_1;
    #define mLED_2_Toggle()     mLED_2 = !mLED_2;
    #define mLED_3_Toggle()     mLED_3 = !mLED_3;
    #define mLED_4_Toggle()     mLED_4 = !mLED_4;
    
    /** SWITCH *********************************************************/
    #define mInitSwitch2()      //TRISAbits.TRISA3=1
        //SW͈ĂȂ߁ASWL܂B
    #define mInitSwitch3()      //TRISAbits.TRISA3=1
    #define sw2                 PORTAbits.RA3
    #define sw3                 PORTAbits.RA3
    #define mInitAllSwitches()  mInitSwitch2();

	/** RS 232 lines ****************************************************/
    #define UART_TRISTx   TRISBbits.TRISB7
    #define UART_TRISRx   TRISBbits.TRISB5
    #define UART_Tx       PORTBbits.RB7
    #define UART_Rx       PORTBbits.RB5
    #define UART_ENABLE   RCSTAbits.SPEN

    /** I/O pin definitions ********************************************/
    #define INPUT_PIN 1
    #define OUTPUT_PIN 0

    //UART̐@\Ausb_config.h ŗLƒ`ĂƂɂ݂̂ɁA
    //ȉ̒`Ӗ܂B
    //ꂼ̃s̐ݒ肪ƂmFĂB
    #define UART_DTS PORTAbits.RA3
    #define UART_DTR LATCbits.LATC3
    #define UART_RTS LATBbits.LATB4
    #define UART_CTS PORTBbits.RB6
    
    #define mInitRTSPin() {TRISBbits.TRISB4 = 0;}   //Configure RTS as a digital output.  
    #define mInitCTSPin() {TRISBbits.TRISB6 = 1;}   //Configure CTS as a digital input.  (Make sure pin is digital if ANxx functions is present on the pin)
    #define mInitDTSPin() {}//{TRISAbits.TRISA3 = 1;}   //Configure DTS as a digital input.  (Make sure pin is digital if ANxx functions is present on the pin)
    #define mInitDTRPin() {TRISCbits.TRISC3 = 0;}   //Configure DTR as a digital output.
	
#endif  //HARDWARE_PROFILE_LOW_PIN_COUNT_USB_DEVELOPMENT_KIT_H
