/********************************************************************
 FileName:     main.c
 Dependencies: See INCLUDES section
 Processor:		PIC18, PIC24, dsPIC, and PIC32 USB Microcontrollers
 Hardware:		̃vÓAMCHPFSUSBT|[gMicrochip 
 				USB demo{[hp̃vO 18F14K50 gp
 				LOW_PIN_COUNT_USB_DEVELOPMENT_KITɊ֘Â
 				o܂B
				ɁAvȃRg{ꉻĂ܂B
 Complier:  	Microchip C18 (for PIC18), C30 (for PIC24/33), C32 (for PIC32)
 Company:		Microchip Technology, Inc.

 쌠F\tgEGẤAMicrochipЂSoftware License Agreement
         ɏ܂ARgȂǂ̒ǉ̒쌠́A҂
         ۗLA҂̋𓾂ȂAŜшꕔ̓]ځEp
         ֎~܂B

********************************************************************
 File Description:

 Change History:
  Rev   Description
  ----  -----------------------------------------
  1.0   18F14K50pƂ{ɖ| 2011/11/01
  2.0   Rev2.9b̗p 2012/5/01
********************************************************************/

/** INCLUDES *******************************************************/
#include "./USB/usb.h"
#include "./USB/usb_function_cdc.h"

#include "HardwareProfile.h"

/** CONFIGURATION **************************************************/
        //14K50
        #pragma config CPUDIV = NOCLKDIV
        #pragma config USBDIV = OFF
        #pragma config FOSC   = HS
        #pragma config PLLEN  = ON
        #pragma config FCMEN  = OFF
        #pragma config IESO   = OFF
        #pragma config PWRTEN = OFF
        #pragma config BOREN  = OFF
        #pragma config BORV   = 30
//        #pragma config VREGEN = ON
        #pragma config WDTEN  = OFF
        #pragma config WDTPS  = 32768
        #pragma config MCLRE  = OFF
        #pragma config HFOFST = OFF
        #pragma config STVREN = ON
        #pragma config LVP    = OFF
        #pragma config XINST  = OFF
        #pragma config BBSIZ  = OFF
        #pragma config CP0    = OFF
        #pragma config CP1    = OFF
        #pragma config CPB    = OFF
        #pragma config WRT0   = OFF
        #pragma config WRT1   = OFF
        #pragma config WRTB   = OFF
        #pragma config WRTC   = OFF
        #pragma config EBTR0  = OFF
        #pragma config EBTR1  = OFF
        #pragma config EBTRB  = OFF       

/** I N C L U D E S **********************************************************/

#include "GenericTypeDefs.h"
#include "Compiler.h"
#include "usb_config.h"
#include "USB/usb_device.h"
#include "USB/usb.h"

#include "HardwareProfile.h"

/** V A R I A B L E S ********************************************************/
#pragma udata
char USB_Out_Buffer[CDC_DATA_OUT_EP_SIZE];
char RS232_Out_Data[CDC_DATA_IN_EP_SIZE];

unsigned char    NextUSBOut;
//char RS232_In_Data;
unsigned char    LastRS232Out;  // obt@Ɋi[Ă镶
unsigned char    RS232cp;       // I
unsigned char RS232_Out_Data_Rdy = 0;
USB_HANDLE  lastTransmission;

//BOOL stringPrinted;


/** P R I V A T E  P R O T O T Y P E S ***************************************/
static void InitializeSystem(void);
void ProcessIO(void);
void USBDeviceTasks(void);
void YourHighPriorityISRCode();
void YourLowPriorityISRCode();
void USBCBSendResume(void);
void BlinkUSBStatus(void);
void UserInit(void);
void InitializeUSART(void);
void putcUSART(char c);
unsigned char getcUSART ();

/** VECTOR REMAPPING ***********************************************/
#if defined(__18CXX)
	//PIC18uł́A0x00A0x080x18AZbgADxƒDx
	//̃xNgɎg܂B
	//AMicrochip USBu[g[_[́A0x00-0xFFF܂
	//0x00-0x7FF ԒngpĂ邽߃u[g[_[ER[h́A
	//xNgȉ̐VꏊɍĔzui}bvj܂B
	//ĔzúÃvWFNgUSBu[g[_[𗘗pHEXt@C
	//vOꍇɕKvłB
	//Au[g[_[𗘗pȂȂusb_config.ht@CҏW
	//ȉ̒`RgAEgĂB
	//#define PROGRAMMABLE_WITH_USB_HID_BOOTLOADER
	//#define PROGRAMMABLE_WITH_USB_LEGACY_CUSTOM_CLASS_BOOTLOADER
	
	#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)
		#define REMAPPED_RESET_VECTOR_ADDRESS			0x1000
		#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x1008
		#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x1018
	#elif defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)	
		#define REMAPPED_RESET_VECTOR_ADDRESS			0x800
		#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x808
		#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x818
	#else	
		#define REMAPPED_RESET_VECTOR_ADDRESS			0x00
		#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x08
		#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x18
	#endif
	
	#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)
	extern void _startup (void);        // See c018i.c in your C18 compiler dir
	#pragma code REMAPPED_RESET_VECTOR = REMAPPED_RESET_VECTOR_ADDRESS
	void _reset (void)
	{
	    _asm goto _startup _endasm
	}
	#endif
	#pragma code REMAPPED_HIGH_INTERRUPT_VECTOR = REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS
	void Remapped_High_ISR (void)
	{
	     _asm goto YourHighPriorityISRCode _endasm
	}
	#pragma code REMAPPED_LOW_INTERRUPT_VECTOR = REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS
	void Remapped_Low_ISR (void)
	{
	     _asm goto YourLowPriorityISRCode _endasm
	}
	
	#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)
	// ̃vWFNgŃu[g[_[̗p`rhꂢꍇ
	//łAo͂HEXt@CɁAu[g[_[̂͊܂܂Ȃ߁A
	// 0x080x18Ԓn܂ރu[g[_̈́AꂸA0xFFFFvO
	// 񂾂̂ƓłB
	// ̌ʁAۂɊꔭƁAPC̓vOĂ
	// ̈ł 0x08i܂0x18jԒńu0xFFFFv߂s܂B 
	// ́unop߁vȂ̂ŌPC͍ĔzuꂽZbgԒn
	// iREMAPPED_RESET_VECTOR_ADDRESSug[_[ɂāA0x1000܂
	// 0x800jɓBAugoto _startupvsAvP[V
	// Zbg邱ƂɂȂ܂B
	//
	// ̏󋵂邽߂ɁAӐ}I
	// 0x08ԒnɁugoto REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESSv
	// 0x18ԒnɁugoto REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESSv
	// ޕKv܂B
	// ̏o͂ꂽHEXt@Cu[g[_[ŏ񂾏ꍇA
	// ̃ZNV̓u[g[_[̈Əd邽ߎۂɂ͏
	// ݂͍s܂B
	// u[g[hgpɁAo͂ꂽHEXt@C񂾏ꍇ
	// ɂ́Aȉgoto߂܂邽߁AHEXt@C̃vO
	// ̏ꍇɂɓ삵܂B
	// ܂ÃZNV́Au[g[_[̎gp錾A
	// u[g[_[gpȂŏ񂾏ꍇz肵pӂꂽ̂B
	// ̃ZNV͏L󋵂邽߂ɕKvȂ̂łB
	#pragma code HIGH_INTERRUPT_VECTOR = 0x08
	void High_ISR (void)
	{
	     _asm goto REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS _endasm
	}
	#pragma code LOW_INTERRUPT_VECTOR = 0x18
	void Low_ISR (void)
	{
	     _asm goto REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS _endasm
	}
	#endif	//end of "#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_LEGACY_CUSTOM_CLASS_BOOTLOADER)"

	#pragma code
	
	
	// @[U[̎ۂɎs@C^vg@vO
	#pragma interrupt YourHighPriorityISRCode
	void YourHighPriorityISRCode()
	{
		//  C^vgC^vg tO`FbN 
		// C^vg[eBLq
		// C^vg tONA
		// Ȃ
        #if defined(USB_INTERRUPT)
	        USBDeviceTasks();
        #endif
	
	}	// #pragma interrupt ZNVȂ̂ "retfie fast"߂Ń^[
	#pragma interruptlow YourLowPriorityISRCode
	void YourLowPriorityISRCode()
	{
		//  C^vgC^vg tO`FbN 
		// C^vg[eBLq
		// C^vg tONA
		// Ȃ

	}	// #pragma interruptlow ZNVȂ̂ "retfie"߂Ń^[


/** DECLARATIONS ***************************************************/
#pragma code

/************************************************************************
 * Function:        void main(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        Main program entry point.
 * Note:            None
 ************************************************************************/
void main(void)
{   
    InitializeSystem();

    #if defined(USB_INTERRUPT)
        USBDeviceAttach();
    #endif

    while(1)
    {
        #if defined(USB_POLLING)
		// Check bus status and service USB interrupts.
        USBDeviceTasks(); // Interrupt  polling@B 
        	  // polling@̗pƂ͕KI
        	  // ̊֐ĂяoƁB̊֐SETUP transactions
        	  // iႦ΁AŏɃvOCenumeration processj
        	  // ł̏ƕԓs܂B
        	  // trazXǵAtrafoCXvZXSETUPpPbg
        	  // x؂ȂM邱ƂvĂ܂BāA
        	  // pollinggꍇAzXgtrafoCXɌSETUP
        	  // pPbg̑M\z鎞ԑт͂̊֐pɁi100
        	  // bjɌĂяoKv܂B قƂǂ̏ꍇA
        	  // USBDeviceTasksij֐͏ɎԂKvƂ킯ł
        	  // ܂i50߃TCNjB
        	  // Interruptpolling@usb_config.hŒ`܂B
        #endif
    				  
		// {̖ړIƂAvP[V^XN AvP[VɊ֘A
		// ^XN͂AProcessIO() ֐ɋLڂ܂B
        ProcessIO();        
    }//end while
}//end main


/********************************************************************
 * Function:        static void InitializeSystem(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        ͂InitializeSystem ōs
 *                  KvƂ邷ׂĂ USB initialization routines
 *                  ͂ĂяoB
 *
 *                  [U[̎gp鏉[eB
 *                  ĂяoƁB      
 *
 * Note:            None
 *******************************************************************/
static void InitializeSystem(void)
{
        ADCON1 |= 0x0F;                 // Default all pins to digital

// USBdlɂtraӑuVbussɓdĂ͂ȂȂƂ
// `ÂĂ܂B ɁAӋ@̓zXg/nuVbusɓd
// ĂȂƂD+܂D-sɓdĂ͂Ȃ܂B
// ioXd𗘗pȂjȓdLtraӋ@݌vꍇA
// ũt@[EFAŁAVbusɓd͂ȂAtraW[
// D+D-s̃vAbvRONɂȂ悤vO܂B 
// VbuszXg쓮Ă邩o@At@[
// EFAKv܂B
// VbusiRŕȂǂj5V͂ɑΉłI/Osɐڑ邱
// ɂAVbusɓdĂizXgd͂ĂjA
// ĂȂizXg̓Vbg_EAd͂ĂȂj
// o܂B
// USBt@[EFAŒIɂI/OsmFiPolling)邱ƂŁAUSB 
// module/D+/D-LɂĂǂm邱Ƃł܂BoXdœ
// ݌v̎ӑȕꍇzXgAVbusɓdĂȂƂD+
// ܂D-ɓd邱Ƃ͕s\Ȃ߁ÃoXĎ@\͕Kvł
// ܂B
// ̃t@[EFÁA	HardwareProfile.ht@C̒ŁuUSE_USB_BUS_
// SENSE_IOv`邱ƂŃoXĎ@\gݍ܂܂B
    #if defined(USE_USB_BUS_SENSE_IO)
    tris_usb_bus_sense = INPUT_PIN; // See HardwareProfile.h
    #endif
    
// zXgPCGetStatus(device)v𑗐MꍇAt@[EFA͉A
// zXgɂtraӑu݁AoXdœ삵Ă邩Aȓd
// 삵Ă邩m点Ȃ΂Ȃ܂Bڍׂ͌USBdlő9
// mFĂB
// ӑuǂ̕@ł삷ꍇÁ݂Aǂ̓dœ삵Ă
// 邩𒲂ׂ̌ʂɂʒmKv܂B 
// PICDEM FS USB Demo BoardƓlȃn[hEFA\Ȃ΁AuRA2vs
// ݂̓dĂ܂B̋@\gp邽߂ɂ́A
// HardwareProfile.hɁuUSE_SELF_POWER_SENSE_IOv`AI/OsK
// ɋLqĂ邱ƂKvłB
    #if defined(USE_SELF_POWER_SENSE_IO)
    tris_self_power = INPUT_PIN;	// See HardwareProfile.h
    #endif
    
    UserInit();

    USBDeviceInit();	//usb_device.c.   USB module SFRs @vO
    					//ϐ
}//end InitializeSystem



/*************************************************************************
 * Function:        void UserInit(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        ɁAdemovOŎgpfoCX̏
 *                  R[hLڂ܂
 * Note:            
 ************************************************************************/
void UserInit(void)
{
	unsigned char i;
    InitializeUSART();

// 	 Initialize the arrays
	for (i=0; i<sizeof(USB_Out_Buffer); i++)
    {
		USB_Out_Buffer[i] = 0;
    }

	NextUSBOut = 0;
	LastRS232Out = 0;
	lastTransmission = 0;

	mInitAllLEDs();
}//end UserInit

/******************************************************************************
 * Function:        void InitializeUSART(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        UART  19200BPSɏ
 * Note:            
 *****************************************************************************/
void InitializeUSART(void)
{
	    unsigned char c;
    	    //ANSELHbits.ANS11 = 0;	// Make RB5 digital so USART can use pin for Rx
            ANSELH = 0;
            #ifndef BAUDCON
                #define BAUDCON BAUDCTL
            #endif
        UART_TRISRx=1;				// RX
        UART_TRISTx=0;				// TX
        TXSTA = 0x24;       	// TX enable BRGH=1
        RCSTA = 0x90;       	// Single Character RX
        SPBRG = 0x71;
        SPBRGH = 0x02;      	// 0x0271 for 48MHz -> 19200 baud
        BAUDCON = 0x08;     	// BRG16 = 1
        c = RCREG;				// read 

}//end InitializeUSART

    #define mDataRdyUSART() PIR1bits.RCIF
    #define mTxRdyUSART()   TXSTAbits.TRMT


/******************************************************************************
 * Function:        void putcUSART(char c)
 * PreCondition:    None
 * Input:           char c - UART瑗o镶
 * Output:          None
 * Side Effects:    None
 * Overview:        Print the input character to the UART
 * Note:            
 *****************************************************************************/
void putcUSART(char c)  
{
	    TXREG = c;
}


/******************************************************************************
 * Function:        void mySetLineCodingHandler(void)
 * PreCondition:    USB_CDC_SET_LINE_CODING_HANDLER is defined
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        ̊֐ SetLineCoding command 󂯕tɌĂ΂B
 *                  ̊֐ v؂ALłbaudrateUpdate
 * Note:            
 *****************************************************************************/
#if defined(USB_CDC_SET_LINE_CODING_HANDLER)
void mySetLineCodingHandler(void)
{
    //ve͈͓mF
    if(cdc_notice.GetLineCoding.dwDTERate.Val > 115200)
    {
        //NOTE: ͈͊Ȍꍇ̏ɂ́A2̕@B́Aō̗p
        //Ă悤ɁAv𖳎ďsȂ@B
        //QԖڂ̕@́AvSTATUS stagestalli~jʒm@łB
        //STALLing the STATUS͗vɁAOʒmiexception thrownjB
        //HyperTerminal̂悤ȃAv́A̗OApop-up boxŐݒ肪 
        //LłȂƂ\BAAvɂẮAOʒm
        //łANbV邱ƂB
        //STATUS stagestalli~jʒm@ȉ̍sɎA
        //̃vOł̓AṽNbV邽߂ɁARgƂĂB
        //---------------------------------------
        //USBStallEndpoint(0,1);
    }
    else
    {
        DWORD_VAL dwBaud;

        // CDC driverbaudrateUpdate
        CDCSetBaudRate(cdc_notice.GetLineCoding.dwDTERate.Val);
        
        // UART baudrateUpdate
            dwBaud.Val = (DWORD)(GetSystemClock()/4)/line_coding.dwDTERate.Val-1;
            SPBRG = dwBaud.v[0];
            SPBRGH = dwBaud.v[1];
    }
}
#endif

/******************************************************************************
 * Function:        void getcUSART(char c)
 * PreCondition:    None
 * Input:           None
 * Output:          unsigned char c -  UARTŎM
 * Side Effects:    None
 * Overview:        Print the input character to the UART
 * Note:            
 *
 *****************************************************************************/
unsigned char getcUSART ()
{
	char  c;

	if (RCSTAbits.OERR)      // overrun erroȑꍇ
	{                        // 
		RCSTAbits.CREN = 0;  // reset port
		c = RCREG;
		RCSTAbits.CREN = 1;  // ċN
	}

	return c;
}

/********************************************************************
 * Function:        void ProcessIO(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        ̊֐ɁA[U[E[`Lq܂B 
 *                  ɂUSB֘AсAUSBɊ֘AȂ̃^XN
 *                  LڂĂ܂B
 * Note:            None
 -------------------------------------------------------------------
  getsUSBUSART(*buffer,len)  USB當MAi[
               *buffer       i[obt@[̃AhX
               len           Mő啶
        ۂUSBM  CDCTxService() sꂽƂ
 -------------------------------------------------------------------
  putUSBUSART(*buffer,len)  USBMobt@ɕi[
               *buffer       M镶obt@[̃AhX
               len           M
      ߂l   unsigned char Mif[^Ȃ́A0j
 *******************************************************************/
void ProcessIO(void)
{   
    // USB device status𔽉fLED_ł܂
    BlinkUSBStatus();
    // USBpɂȂ܂ł́AɃ^[
    if((USBDeviceState < CONFIGURED_STATE)||(USBSuspendControl==1)) return;
    // ------------- PC USB  UART VAo --------------
    if (RS232_Out_Data_Rdy == 0)  // ׂĂUSBMf[^ꂽƂ
    {                             // mFĂAUSBf[^MB
        LastRS232Out = getsUSBUSART(RS232_Out_Data,64); //USBMsA
        if(LastRS232Out > 0)                            //f[^MȂA
        {    
            RS232_Out_Data_Rdy = 1;    // USBMtOf[^LɃZbg
            RS232cp = 0;               // ς݃|C^̃Zbg
        }
    }

    //USB̃f[^UARTM҂HUART͑M\H
    //mFA\łΈꕶUARTőM@USBUART
    if(RS232_Out_Data_Rdy && mTxRdyUSART())
    {
        #if defined(USB_CDC_SUPPORT_HARDWARE_FLOW_CONTROL)
            //t[gpĂꍇAM\mF 
            //f[^ꕶUARTőM
            if(UART_CTS == USB_CDC_CTS_ACTIVE_LEVEL)
            {
                putcUSART(RS232_Out_Data[RS232cp]);
                ++RS232cp;
                if (RS232cp == LastRS232Out)  //M҂obt@
                    RS232_Out_Data_Rdy = 0;   //SđMIB
            }
        #else
            //t[gpĂȂꍇA
            //ɁAꕶUARTM
            putcUSART(RS232_Out_Data[RS232cp]);
            ++RS232cp;
            if (RS232cp == LastRS232Out)  //M҂obt@
                RS232_Out_Data_Rdy = 0;   //SđMIB
        #endif
    }

    //UARTf[^MĂAUSBŃzXgPCɑM邽߂
    //Mf[^obt@Ɋi[@UARTUSB
    if(mDataRdyUSART() && (NextUSBOut < (CDC_DATA_OUT_EP_SIZE - 1)))
    {
        USB_Out_Buffer[NextUSBOut] = getcUSART();
        ++NextUSBOut;
        USB_Out_Buffer[NextUSBOut] = 0;  //ŌNullړ
    }
    
    #if defined(USB_CDC_SUPPORT_HARDWARE_FLOW_CONTROL)
        //t[gpĂꍇA
        //USBM҂f[^(NextUSBOut)tɋ߂΁A
        //RTSsACTIVEƂ󋵂ʒmB 
        if(NextUSBOut <= (CDC_DATA_OUT_EP_SIZE - 5u))
        {
            UART_RTS = USB_CDC_RTS_ACTIVE_LEVEL;
        }       
        else
        {
            UART_RTS = (USB_CDC_RTS_ACTIVE_LEVEL ^ 1);
        }    
    #endif    

    //USBM҂obt@Ƀf[^(NextUSBOut)A
    //USBM\ȏԂł΁A
    //USB packetƂđMB
    if((USBUSARTIsTxTrfReady()) && (NextUSBOut > 0))
    {
        putUSBUSART(&USB_Out_Buffer[0], NextUSBOut);
        NextUSBOut = 0;       //USBM҂obt@ɂ
    }

    CDCTxService();           //ۂUSBM{

}//end ProcessIO

/********************************************************************
 * Function:        void BlinkUSBStatus(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        USB device status𔽉fLED_ł܂ 
 *
 * Note:            mLED macros  HardwareProfile.hɋLڂĂ܂
 *                  USBDeviceState ́Ausb_device.hŒ`
 *                  ̏ԂUpDates܂
 *******************************************************************/
void BlinkUSBStatus(void)
{
    static WORD led_count=0;
    
    if(led_count == 0)led_count = 10000U;
    led_count--;

    #define mLED_Both_Off()         {mLED_1_Off();mLED_2_Off();}
    #define mLED_Both_On()          {mLED_1_On();mLED_2_On();}
    #define mLED_Only_1_On()        {mLED_1_On();mLED_2_Off();}
    #define mLED_Only_2_On()        {mLED_1_Off();mLED_2_On();}

    if(USBSuspendControl == 1)
    {
        if(led_count==0)
        {
            mLED_1_Toggle();
            if(mGetLED_1())
            {
                mLED_2_On();
            }
            else
            {
                mLED_2_Off();
            }
        }//end if
    }
    else
    {
        if(USBDeviceState == DETACHED_STATE)
        {
            mLED_Both_Off();
        }
        else if(USBDeviceState == ATTACHED_STATE)
        {
            mLED_Both_On();
        }
        else if(USBDeviceState == POWERED_STATE)
        {
            mLED_Only_1_On();
        }
        else if(USBDeviceState == DEFAULT_STATE)
        {
            mLED_Only_2_On();
        }
        else if(USBDeviceState == ADDRESS_STATE)
        {
            if(led_count == 0)
            {
                mLED_1_Toggle();
                mLED_2_Off();
            }//end if
        }
        else if(USBDeviceState == CONFIGURED_STATE)
        {
            if(led_count==0)
            {
                mLED_1_Toggle();
                if(mGetLED_1())
                {
                    mLED_2_Off();
                }
                else
                {
                    mLED_2_On();
                }
            }//end if
        }//end if(...)
    }//end if(UCONbits.SUSPND...)

}//end BlinkUSBStatus


// ******************************************************************************************************
// ************** USB Callback Functions ****************************************************************
// ******************************************************************************************************
// USBt@[EFAEX^bŃAUSBCxgɉăR[obN
// ֐USBCBxxxijĂяo܂B
// Ƃ΁AzXgPCdOFFɂƂ́AUSBuւStart of Frame
//  iSOFj̑M~߂܂B ɉāAׂĂ̂traúAUSB 
// Vbus̏dꂼ2.5mA Ɍ܂B
// traW[́ȀԁiUSBdlɂ΁A3msȏ̉̒ʐM/SOF
// pPbgsĂȂԁjoƁAUSBCBSuspendijĂт
// ܂B[U[́Ȁ󋵂ɓK؂ȑ[uƂ悤R[obN
// ֐CȂ΂Ȃ܂B
// Ƃ΁AUSBCBSuspendijł́AiNbNύXALEDItɂ
// ACPUX[v肵ājdR[hsVbus
// ̏d2.5mAɂ܂B
// ̌AUSBCBWakeFromSuspendij֐ł́AUSBCBSuspendij֐Ŏ{
// ȓd͂ɖ߂R[hs邱ƂɂȂ܂B
// USBX^bNIɌĂ΂ȂƂ_ŁAUSBCBSendResumeij֐
// ͓ʂłB ̊֐́AAvP[VEt@[EFAĂ΂
// ֐łBڂ͕ʂ̃RgQƂĂB
/**************************************************************************
 * Function:        void USBCBSuspend(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        Call back that is invoked when a USB suspend is detected
 *
 * Note:            None
 *****************************************************************************/
void USBCBSuspend(void)
{
// Example power saving code 
// AvP[Vɖ]܂K؂ȏȓd̓R[hɋLڂB
//  }CNRg[X[vȂALɎ菇
// ގvZXgpF
//
// ConfigureIOPinsForLowPowerij;
// SaveStateOfAllInterruptEnableBitsij;
// DisableAllInterruptEnableBitsij;
// EnableOnlyTheInterruptsWhichWillBeUsedToWakeTheMicroij; 
//    ċNiwakeĵߏȂƂUSBActivityIF͉ғ
// Sleep();
// RestoreStateOfAllPreviouslySavedInterruptEnableBitsij; 
//    o΁AUSBCBWakeFromSuspendij֐ɂ̑֋@\𐷍ށB
// RestoreIOPinsToNormalij; 
//    o΁AUSBCBWakeFromSuspendij֐ɂ̑֋@\𐷍ށB
// 
// dvF USBActivityIFiACTVIFjrbgNAĂ͂ȂȂB 
// ̃rbgusb_device.ct@CŃNABUSBActivityIF
// NAƈӐ}铮sȂȂB	
//  ȓd͉R[hB KvɂK؂ȃR[hɑ}
	
}


/******************************************************************************
 * Function:        void _USB1Interrupt(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        ̊֐ USB interrupt bit ZbgƌĂ΂B
 *					̗ł́A interrupt  USB suspend command 
 *					foCX sleep ɔ
 * Note:            None
 *****************************************************************************/
#if 0
void __attribute__ ((interrupt)) _USB1Interrupt(void)
{
    #if !defined(self_powered)
        if(U1OTGIRbits.ACTVIF)
        {
            IEC5bits.USB1IE = 0;
            U1OTGIEbits.ACTVIE = 0;
            IFS5bits.USB1IF = 0;
        
            //USBClearInterruptFlag(USBActivityIFReg,USBActivityIFBitNum);
            USBClearInterruptFlag(USBIdleIFReg,USBIdleIFBitNum);
            //USBSuspendControl = 0;
        }
    #endif
}
#endif

/****************************************************************************
 * Function:        void USBCBWakeFromSuspend(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        zXǵAi3+ms̃AChuvƂŁjtraӑu
 *					dSuspend[hɂ邱ƂB Suspend[h̎ɁA
 *					zXǵAAChȊO̐M𑗂邱ŁAuĂыN
 *					iWake)B
 *					̃R[obŃAUSB suspend ̋NiWakeup)o
 *					ꂽƂɎ{B
 * Note:            None
 ************************************************************************/
void USBCBWakeFromSuspend(void){
 // NbN̕ύX⑼̏ȓd͏uƂAUSBCBSuspendijsāA
 // ̌Aʏ̃tp[샂[hւ̈ڍs鎞@zXg
 // 2 - 3~b̃X[vԂ݂Ă܂B̊Ԃɑu͒ʏ
 // ɖ߂AUSBpPbg󂯂āAł悤ɂȂKv
 // ܂B邽߂ɁAtraW[́AK؂ȃNbN
 // ɖ߂Kv܂iIEFtXs[hUSBSIE𗘗pɂ
 // 48MHz̃NbNKvłjB
}

/********************************************************************
 * Function:        void USBCB_SOF_Handler(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        trazXǵAfull-speedu1msSOFpacket
 *                  o܂B ̊荞݂͒IȃAC\NiX]
 *                   pꍇ܂B
 *                  KvɉăR[obNE[`ɎĂB
 * Note:            None
 *******************************************************************/
void USBCB_SOF_Handler(void)
{
    // UIRbits.SOFIF  0 ɃNAKv͂܂
    // Callback caller ɂ̏{Ă܂B
}

/*******************************************************************
 * Function:        void USBCBErrorHandler(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:    ̃R[obN̖ړÍAɊJ̃fobOłB
 *              UEIR`FbNǂ̃G[A荞݂N
 *              邱Ƃł܂ 
 *
 * Note:            None
 *******************************************************************/
void USBCBErrorHandler(void){
  // UEIR0ɃNAKv͂܂BłɃR[obN
  // NAĂ܂B
  // ʓIɁA[U[Et@[EFAł́AɉKv͂
  // ܂BUSBG[BƂ΁A zXgOUTpPbg𑗐M
  // Auւ̃pPbg͂ȂƂiFڐGsǂA
  // traP[ũvO𔲂ȂǁjAɂAʏȏUSB
  // G[荞݂܂BASIEIɁuNAKvpPbg
  // zXgɑMĂAɉKv͂܂B
  // ʏzXg̓pPbgđ邽߂Ƀf[^͋N܂B
  // VXéAʓIɃAvP[VEt@[EFȀKv
  // AIɕ܂B܂ÃR[obN@\̓fobO
  // ړÎ߂ɒ񋟂Ă܂B 
}


/*******************************************************************
 * Function:        void USBCBCheckOtherReq(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        SETUPpPbgzXg瓞ƂA
 *                  t@[EFAɂẮAv𖞂߂
 *                  K؂ɁAf[^𑗐MAȂ΂Ȃ܂B
 *                  SETUPpPbg̈ꕔ́AstandardUSB "chapter 9"
 *                  iUSBdl̑9͂𖞂߁jɏ]܂A
 *                  USBfoCXNXL̂̂܂B Ƃ΁AHID
 *                  úuGET REPORTvɉKv܂B
 *                   ͎dl̑9̗͂vłȂ߁Ausb_device.cł
 *                  舵܂B̑ɁÃNX舵
 *                  t@[EFAƂ usb_function_hid.c.Ɋ܂܂܂
 *
 * Note:            None
 *******************************************************************/
void USBCBCheckOtherReq(void)
{
    USBCheckCDCRequest();
}//end


/*******************************************************************
 * Function:        void USBCBStdSetDscHandler(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        USBCBStdSetDscHandlerijR[obN@\́ASETUP,
 *					bRequestFSET_DESCRIPTORv̎MɌĂ΂܂B
 *					ʓIɁASET_DESCRIPTORv͑命̃AvP[
 *					VŎg܂B
 *					̗̎vT|[g邱Ƃ̓IvVłB
 *
 * Note:            None
 *******************************************************************/
void USBCBStdSetDscHandler(void)
{
    // Must claim session ownership if supporting this request
}//end


/*******************************************************************
 * Function:        void USBCBInitEP(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        uƂA̋@\Ă΂܂
 *                  zXgSET_CONFIGURATION(wValue not = 0)𑗂Ƃ
 *                  vłB̃R[obN@\́Au̎{
 *                  鏈ɕKvƂȂGh|Cg̏s܂
 *
 * Note:            None
 *******************************************************************/
void USBCBInitEP(void)
{
    CDCInitEP();
}

/********************************************************************
 * Function:        void USBCBSendResume(void)
 * PreCondition:    None
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        TUSBdĺAUSBӑuɃzXgPCwake up
 *		邱Ƃ܂iƂlow power suspendRAMȂǁjB
 *		́A̂traAvP[VŔɖɗ@\ł
 *		iႦΐԊORjB [U[ԊOŔudv{^
 *		AԊOV[o[́A̐MMAPCUSB
 *		 "command" 𑗐MPC wake upo΂͑f炵ƂłB
 *					
 *		USBCBSendResumeijR[obN@\A̓ʂUSBM𑗐M
 *		PCwakes up̂Ɏg܂B̋@\́AAvP[VE
 *		t@[EFAPCwakes up̂ɌĂяoƂł܂B 
 *		A̋@\́AL̑SĂ𖞂Kv܂F
 *					
 *					1.  PCgĂUSBhCo[Aremote wakeup@\
 *						T|[g
 *					2.  USB configuration descriptorbmAttributes
 *						tB[hremote wakeup capableƋLqĂB
 *					3.  zXgPC͌݃X[vĂāAȑOUSBu
 *						remote wakeup@\"armed"ɂSET FEATURE 
 *						̃Zbg AbvpPbg𑗐MĂ
 *
 *                  zXgremote wakeup armed ԂɂĂȂꍇA
 *                  ̋@\remote wakeupN^[܂B
 *                  ́A߂ꂽłA remote wakeup armed 
 *                  ԂɂȂtrauremote wakeupMoX
 *                  ɑMĂ͂܂;MƁA
 *                  USB compliance testing failure𔭐܂B
 *
 *                  ̃R[obŃA1-15ms̊ԁARESUMEM𑗂Ȃ
 *                  ΂Ȃ܂B
 *
 * Note:            USBoXƃzXgsuspendedԁA΁Aremote 
 *                  wakeup readyԂɂȂȂ΁A̋@\͉ȂŁA
 *                  ɖ߂܂B
*                   āAIɂ̋@\ĂłSłA
 *                  AvP[VCӂ̃^C~OŌĂяoĂA
 *                  oX{remote wakeup󂯓ԂłȂ
 *                  e^܂B
 *
  *                  ̋@\sɍ킹AUSBCBWakeFromSuspendij̒
 *                  ŃNbNύXĂKv邩܂B
 *                  ȂȂUSBoX͂̋@\A^[ƂɁA
 *                  suspendedł͂Ȃ߁AUSBW[̓zXg
 *                  MM鏀łĂł邱ƂKvłB
 *
 *                  ̃[`̏C\ZNV́AAvP[VE
 *                  j[Y𖞂߂ɕύXKv܂B 
 *                  ݂̎bݒ́A\IȃNbNgő̋@\
 *                  s3-15 ms̊ԃubN܂B
 *
 *                  USB 2.0dlsection7.1.7.7ɂƁAuremote wakeup 
 *                  úAȂƂ1 msȏA15 msȉ̊resumeM
 *                  ێȂ΂Ȃ܂v ̓́Adelay counter 
 *                  loopgp邱ƂŎĂ܂Bȉ̈ʂȒl
 *                  gp邱ƂōL͈͂ɂ킽RAgœ\łB

 *                  That value selected is 1800. See table below:
 *                  =======================================================
 *                  Core Freq(MHz)      MIP      RESUME Signal Period (ms)
 *                  =======================================================
 *                      48              12          1.05
 *                       4              1           12.6
 *                  =======================================================
 *                  * ̃^C~O̓R[hœK܂͊g߃[h
 *                    ̎gp⑼̊荞݂\ɂĂƂƁAقȂ
 *                    ꍇ܂B KMPLAB SIMStopwatch@\IV
 *                    XR[vŎۂ̐Mm߂悤ɂĂB 
*******************************************************************/
void USBCBSendResume(void)
{
    static WORD delay_count;
    
    // 1ɂ́AzXgremote wakeups邽߂armedĂ邱Ƃ
    // m߂ĂBremote wakeup\ɂɂ́AʏzXg
    // standby modeɂȂ钼OSET_FEATURE𑗐M邱Ƃɂčs܂A
    // F configuration descriptorremote wakeup capableƋLq
    // AzXg̋@\Cl[uĂ΁ASET_FEATUREv𑗐M
    // 邾łB
    // Windowsx[X̃zXg̋@\Cl[úAfoCX}l[W
    // trauvpeB\p[}lWgE^uI
    // "Allow this device to bring the computer out of standby."  
    // `FbN{bNX`FbNĂ邱
    if(USBGetRemoteWakeupStatus() == TRUE) 
    {
        //Verify that the USB bus is in fact suspended, before we send
        //remote wakeup signalling.
        if(USBIsBusSuspended() == TRUE)
        {
            USBMaskInterrupts();
            
            //Clock switch to settings consistent with normal USB operation.
            USBCBWakeFromSuspend();
            USBSuspendControl = 0; 
            USBBusIsSuspended = FALSE;  //So we don't execute this code again, 
                                        //until a new suspend condition is detected.

            // USB 2.0dl̑7.1.7.7߂́AUSBúAremote wakeup
            // MOɁAoXŃAChAI5ms+ĎȂ
            // ΂Ȃ܂B̗v̕@ƂāA2ms+
            // blocking delayǉĂ܂B
            //  USBIsBusSuspended() == TRUEŊmFĂ鏭ȂƂ3ms
            // ̃oXACh2msǉ邱ƂŃACh̃X^[g
            // v5ms+ƂȂ܂B
            delay_count = 3600U;        
            do
            {
                delay_count--;
            }while(delay_count);
            
            //Now drive the resume K-state signalling onto the USB bus.
            USBResumeControl = 1;       // Start RESUME signaling
            delay_count = 1800U;        // Set RESUME line for 1-13 ms
            do
            {
                delay_count--;
            }while(delay_count);
            USBResumeControl = 0;       //Finished driving resume signalling

            USBUnmaskInterrupts();
        }
    }
}

/*******************************************************************
 * Function:        void USBCBEP0DataReceived(void)
 * PreCondition:    ENABLE_EP0_DATA_RECEIVED_CALLBACK must be
 *                  defined already (in usb_config.h)
 * Input:           None
 * Output:          None
 * Side Effects:    None
 * Overview:        EP0f[^pPbgMꂽ͂łA̋@\
 *                  Ă΂܂́A낢ȃNXŗpcontrol
 *                  endpointgpf[^擾@Ꭶ܂B
 *                  ̋@\́AUSBCBCheckOtherReqijƈꏏɎgKv
 *                  ܂BUSBCBCheckOtherReqij@\́Af[^
 *                  Oɍŏcontrol MAvłB

 *
 * Note:            None
 *******************************************************************/
#if defined(ENABLE_EP0_DATA_RECEIVED_CALLBACK)
void USBCBEP0DataReceived(void)
{
}
#endif

/*******************************************************************
 * Function:        BOOL USER_USB_CALLBACK_EVENT_HANDLER(
 *                        USB_EVENT event, void *pdata, WORD size)
 * PreCondition:    None
 * Input:           USB_EVENT event - the type of event
 *                  void *pdata - pointer to the event data
 *                  WORD size - size of the event data
 * Output:          None
 * Side Effects:    None
 * Overview:        ̋@\́AUSBCxgƂ[UAvP
 *                  [Vɒʒm邽߂ɁAUSBX^bNĂ΂܂B
 *                   USB_INTERRUPTIvVIĂƂA
 *                  R[obN͊ݏɂ܂B
 *
 * Note:            None
 *******************************************************************/
BOOL USER_USB_CALLBACK_EVENT_HANDLER(USB_EVENT event, void *pdata, WORD size)
{
    switch(event)
    {
        case EVENT_TRANSFER:
            //Add application specific callback task or callback function here if desired.
            break;
        case EVENT_SOF:
            USBCB_SOF_Handler();
            break;
        case EVENT_SUSPEND:
            USBCBSuspend();
            break;
        case EVENT_RESUME:
            USBCBWakeFromSuspend();
            break;
        case EVENT_CONFIGURED: 
            USBCBInitEP();
            break;
        case EVENT_SET_DESCRIPTOR:
            USBCBStdSetDscHandler();
            break;
        case EVENT_EP0_REQUEST:
            USBCBCheckOtherReq();
            break;
        case EVENT_BUS_ERROR:
            USBCBErrorHandler();
            break;
        case EVENT_TRANSFER_TERMINATED:
            //KvɉĕKvȃAvP[VpR[obN^XN܂
            //R[obN@\ɉĂB
            //EVENT_TRANSFER_TERMINATED́Aarmed iUOWN= 1jĂAv
            //P[VEGh|CgɁAzXgCLEARFEATURE
            //(endpoint halt)vsƂɔ܂B
            //ȉ̋@\́AɒuƗǂł傤F
            //1.  *pdatãnhl`FbN邱ƂɂāAǂ̃Gh
            //    |CgŁAʐMÎB
            //2.  KvɉăGh|CgRe-arm
            //     iʓIɂOUTGh|Cg̏ꍇj
            break;
        default:
            break;
    }      
    return TRUE; 
}

/** EOF main.c *************************************************/
